Imports System.Data.SqlClient
Imports System.Transactions
Imports System.IO.Directory

Public Class Form1
   Private strConn As String = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
   GetCurrentDirectory.Substring(0, GetCurrentDirectory.Length - 10) & _
   "\dbsTransaction.mdf;Integrated Security=True;User Instance=True"

   Private Sub cmdNormal_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles cmdNormal.Click
      AddToTable_WithoutTransaction()
   End Sub

   Private Sub AddToTable_WithoutTransaction()
      Dim sqlConnection1 As New SqlConnection(strConn)
      Dim sqlDataAdapter1 As New SqlDataAdapter
      Dim intMax As Integer = GetMaximum("ID") + 1
      Dim strQuery As String = _
      "Insert Into tblEmployee (ID, LastName, FirstName, Gender, City) " & _
      "Values(" & intMax & ", 'Sarabi', 'Reza', 'Male', 'Zahedan')"
      Dim sqlCommand1 As New SqlCommand(strQuery, sqlConnection1)
      sqlDataAdapter1.InsertCommand = sqlCommand1

      Try
         sqlConnection1.Open()
         sqlCommand1.ExecuteNonQuery()
         MessageBox.Show("Insert operation was successful.", "Normal")
      Catch ex As Exception
         MessageBox.Show("An error occured!")
      End Try
      sqlConnection1.Close()
   End Sub

   Private Sub cmdCommitableTransaction_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles cmdCommitableTransaction.Click
      AddToTable_CommitableTransaction()
   End Sub

   Private Sub AddToTable_CommitableTransaction()
      Dim sqlTransaction1 As New CommittableTransaction
      Dim sqlConnection1 As New SqlConnection(strConn)
      Dim sqlDataAdapter1 As New SqlDataAdapter

      Dim intMax As Integer = GetMaximum("ID") + 1
      Dim strQuery As String = _
      "Insert Into tblEmployee (ID, LastName, FirstName, Gender, City) " & _
      "Values(" & intMax & ", 'Akbari', 'Hamid', 'Male', 'Mashhad')"
      Dim sqlCommand1 As New SqlCommand(strQuery, sqlConnection1)
      sqlDataAdapter1.InsertCommand = sqlCommand1

      Try
         sqlConnection1.Open()
         sqlConnection1.EnlistTransaction(sqlTransaction1)
         sqlCommand1.ExecuteNonQuery()
         sqlTransaction1.Commit()
         MessageBox.Show("Insert operation was successful.", _
         "Commitable Transaction")

      Catch ex As Exception
         sqlTransaction1.Rollback()
         MessageBox.Show("An error occured!")
      End Try
      sqlConnection1.Close()
      sqlTransaction1.Dispose()
   End Sub

   Private Sub cmdSqlTransaction_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles cmdSqlTransaction.Click
      AddToTable_SqlTransaction()
   End Sub

   Private Sub AddToTable_SqlTransaction()
      Dim sqlTransaction1 As SqlTransaction
      Dim sqlConnection1 As New SqlConnection(strConn)
      Dim sqlDataAdapter1 As New SqlDataAdapter

      Dim intMax As Integer = GetMaximum("ID") + 1
      Dim strQuery As String = _
      "Insert Into tblEmployee (ID, LastName, FirstName, Gender, City) " & _
      "Values(" & intMax & ", 'Ameri', 'Naser', 'Male', 'Bushehr')"
      Dim sqlCommand1 As New SqlCommand(strQuery, sqlConnection1)
      sqlDataAdapter1.InsertCommand = sqlCommand1

      Try
         sqlConnection1.Open()
         sqlTransaction1 = sqlConnection1.BeginTransaction("First")
         sqlCommand1.Transaction = sqlTransaction1
         sqlCommand1.ExecuteNonQuery()
         sqlTransaction1.Save("First")
         sqlTransaction1.Commit()

         intMax = GetMaximum("ID") + 1
         strQuery = "Insert Into tblEmployee (ID, LastName, FirstName, " & _
         "Gender, City) Values(" & intMax & ", 'Ghasemi', 'Omid', 'Male', 'Sari')"
         sqlCommand1 = New SqlCommand(strQuery, sqlConnection1)
         sqlDataAdapter1.InsertCommand = sqlCommand1
         sqlTransaction1 = sqlConnection1.BeginTransaction("Second")
         sqlCommand1.Transaction = sqlTransaction1

         Try
            sqlCommand1.ExecuteNonQuery()
            sqlTransaction1.Commit()
            MessageBox.Show("Insert operation was successful.", "Sql Transaction")
         Catch ex1 As Exception
            sqlTransaction1.Rollback("Second")
            MessageBox.Show("An error occured!")
         End Try

      Catch ex2 As Exception
         MessageBox.Show("An error occured!")
      End Try
      sqlConnection1.Close()
   End Sub

   Private Sub cmdTransactionScop_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles cmdTransactionScop.Click
      AddToTable_TransactionScop()
   End Sub

   Private Sub AddToTable_TransactionScop()
      Dim sqlConnection1 As New SqlConnection(strConn)
      Dim sqlDataAdapter1 As New SqlDataAdapter

      Dim intMax As Integer = GetMaximum("ID") + 1
      Dim strQuery As String = _
      "Insert Into tblEmployee (ID, LastName, FirstName, Gender, City) " & _
      "Values(" & intMax & ", 'Ahmadi', 'Ali', 'Male', 'Yazd')"
      Dim sqlCommand1 As New SqlCommand(strQuery, sqlConnection1)
      sqlDataAdapter1.InsertCommand = sqlCommand1
      Dim sqlTransaction1 As New TransactionScope

      Try
         sqlConnection1.Open()
         sqlCommand1.ExecuteNonQuery()
         sqlTransaction1.Complete()
         MessageBox.Show("Insert operation was successful.", "Transaction Scop")

      Catch ex As Exception
         MessageBox.Show(ex.Message)
      End Try
      sqlConnection1.Close()
      sqlTransaction1.Dispose()
   End Sub

   Private Sub cmdExit_Click(ByVal sender As System.Object, _
   ByVal e As System.EventArgs) Handles cmdExit.Click
      End
   End Sub

   Public Function GetMaximum(ByVal ColumnName As String) As Long
      Dim bolError As Boolean = True
      Dim strMaxNum As String = 0
      Dim strQuery As String = " Select Max(" & ColumnName & ") From tblEmployee"
      Dim sqlConnection1 As New SqlConnection(strConn)
      Dim sqlCommand1 As New SqlCommand(strQuery, sqlConnection1)
      sqlCommand1.CommandText = strQuery

      Try
         sqlConnection1.Open()
         If IsNumeric(sqlCommand1.ExecuteScalar) Then
            strMaxNum = CLng(sqlCommand1.ExecuteScalar)
         Else
            strMaxNum = 0
         End If
         bolError = False

      Catch expAny As Exception
         MessageBox.Show("An error occured!")
      End Try
      sqlConnection1.Close()
      sqlCommand1.Dispose()

      If bolError = True Then
         Return -1
      End If

      Return CLng(strMaxNum)
   End Function
End Class
